{
  edition = 201909;

  description = "Genode packages";

  inputs = {
    nixpkgs.uri = "git+https://gitea.c3d2.de/ehmry/nixpkgs.git";
    dhall-haskell.uri =
      "git+https://github.com/dhall-lang/dhall-haskell?ref=flake";
  };

  outputs = { self, nixpkgs, dhall-haskell }:
    let
      nixpkgs' = import nixpkgs;
      systems = [ "x86_64-genode" ];

      forAllSystems = f: nixpkgs.lib.genAttrs systems (system: f system);

    in {

      lib = import ./lib { genodepkgs = self; inherit nixpkgs dhall-haskell; };

      packages = forAllSystems (system:
        import ./packages.nix {
          inherit system;
          nixpkgs = nixpkgs';
        });

      checks = forAllSystems (system:
        import ./tests {
          inherit self nixpkgs dhall-haskell;
          genodepkgs = builtins.getAttr system self.packages;
        });
    };
}
